package com.engine.jucailinkq.attendance.component.ImportAndExport.service;

import com.engine.jucailinkq.attendance.component.ImportAndExport.service.param.ImportParam;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import java.util.Map;

/**
 * @Author: sy
 * @Description: excel文件导出导入
 * @Date: 2024/6/5
 **/
public interface ExcelExportImportService {

    /**
     * 日历排班页面中的排班列表导出
     * @param paramMap
     * @return
     */
    XSSFWorkbook exportSchedule(Map<String,Object> paramMap);

    /**
     * 日历排班页面中的排班列表导入
     * @param param
     * @return
     */
    Map<String, Object> importSchedule(ImportParam param);

    /**
     * 日历排班页面中的排班列表导入-预览
     * @param param
     * @return
     */
    Map<String, Object> previewImportSchedule(ImportParam param);
}
